Index: backend/utils/error/elog.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/utils/error/elog.c,v
retrieving revision 1.161
diff -c -r1.161 elog.c
*** backend/utils/error/elog.c	10 Jun 2005 20:48:54 -0000	1.161
--- backend/utils/error/elog.c	28 Jul 2005 20:20:14 -0000
***************
*** 1266,1271 ****
--- 1266,1272 ----
  static void
  write_eventlog(int level, const char *line)
  {
+ 	int eventlevel = EVENTLOG_ERROR_TYPE;
  	static HANDLE evtHandle = INVALID_HANDLE_VALUE;
  
  	if (evtHandle == INVALID_HANDLE_VALUE)
***************
*** 1278,1285 ****
  		}
  	}
  
  	ReportEvent(evtHandle,
! 				level,
  				0,
  				0,				/* All events are Id 0 */
  				NULL,
--- 1279,1311 ----
  		}
  	}
  
+ 	switch (level)
+ 	{
+ 		case DEBUG5:
+ 		case DEBUG4:
+ 		case DEBUG3:
+ 		case DEBUG2:
+ 		case DEBUG1:
+ 		case LOG:
+ 		case COMMERROR:
+ 		case INFO:
+ 		case NOTICE:
+ 			eventlevel = EVENTLOG_INFORMATION_TYPE;
+ 			break;
+ 		case WARNING:
+ 			eventlevel = EVENTLOG_WARNING_TYPE;
+ 			break;
+ 		case ERROR:
+ 		case FATAL:
+ 		case PANIC:
+ 		default:
+ 			eventlevel = EVENTLOG_ERROR_TYPE;
+ 			break;
+ 	}
+ 
+ 
  	ReportEvent(evtHandle,
! 				eventlevel,
  				0,
  				0,				/* All events are Id 0 */
  				NULL,
***************
*** 1634,1665 ****
  	/* Write to eventlog, if enabled */
  	if (Log_destination & LOG_DESTINATION_EVENTLOG)
  	{
! 		int			eventlog_level;
! 
! 		switch (edata->elevel)
! 		{
! 			case DEBUG5:
! 			case DEBUG4:
! 			case DEBUG3:
! 			case DEBUG2:
! 			case DEBUG1:
! 			case LOG:
! 			case COMMERROR:
! 			case INFO:
! 			case NOTICE:
! 				eventlog_level = EVENTLOG_INFORMATION_TYPE;
! 				break;
! 			case WARNING:
! 				eventlog_level = EVENTLOG_WARNING_TYPE;
! 				break;
! 			case ERROR:
! 			case FATAL:
! 			case PANIC:
! 			default:
! 				eventlog_level = EVENTLOG_ERROR_TYPE;
! 				break;
! 		}
! 		write_eventlog(eventlog_level, buf.data);
  	}
  #endif   /* WIN32 */
  
--- 1660,1666 ----
  	/* Write to eventlog, if enabled */
  	if (Log_destination & LOG_DESTINATION_EVENTLOG)
  	{
! 		write_eventlog(edata->elevel, buf.data);
  	}
  #endif   /* WIN32 */
  
***************
*** 1675,1681 ****
  		 * because that's really a pipe to the syslogger process.
  		 */
  		if ((!Redirect_stderr || am_syslogger) && pgwin32_is_service())
! 			write_eventlog(EVENTLOG_ERROR_TYPE, buf.data);
  		else
  #endif
  			fprintf(stderr, "%s", buf.data);
--- 1676,1682 ----
  		 * because that's really a pipe to the syslogger process.
  		 */
  		if ((!Redirect_stderr || am_syslogger) && pgwin32_is_service())
! 			write_eventlog(edata->elevel, buf.data);
  		else
  #endif
  			fprintf(stderr, "%s", buf.data);
